#ifndef CALENDARITEM_H
#define CALENDARITEM_H

#include "Date.h"
#include "Time.h"

class CalendarItem {

public:
  CalendarItem();
  CalendarItem(Date date, Time time, int duration, string description);
  friend ostream& operator <<(ostream& sout, const CalendarItem& ci);
  const Date GetDate() const;
  const Time GetTime() const;
  int GetDuration() const;
  bool Conflict(const CalendarItem &appt) const;

private:
  Date m_date;             // Event date
  Time m_time;             // Event start time
  int m_duration;          // Event duration in minutes
  string m_description;    // Event description

};

#endif
