#ifndef DATE_H
#define DATE_H

class Date {

public:
  Date();
  Date(int month, int day, int year);
  friend ostream& operator <<(ostream &sout, const Date &d);
  int GetDay() const;
  int GetMonth() const;
  int GetYear() const;

private:
  int m_month;
  int m_day;
  int m_year;
};

// can overload standard operators: 
//  +, -, ==, <, > , <=, >=, [], etc.

// ostream& operator <<(ostream &sout, const Date &d);

bool operator ==(const Date &d1, const Date &d2);

// notice the "operator" keyword
bool operator >(const Date &d1, const Date &d2);

// bool GreaterThan(const Date &d1, const Date &d2);
// call with GreaterThan(d1, d2);

bool operator <(const Date &d1, const Date & d2);
bool operator <=(const Date &d1, const Date &d2);
bool operator >=(const Date &d1, const Date &d2);
bool operator !=(const Date &d1, const Date &d2);


#endif


